
# Moody #

This software is in alpha: it still has some rough edges.
For example there is still no support for folders in master.

See [CONTRIBUTING.md](/CONTRIBUTING.md) for informations about how it works.

## Quick Install ##

For Arch Linux, there is the [https://aur.archlinux.org/packages/epfl-moody-git/](epfl-moody-git) AUR package.  
Fedora and Debian packages are planned.

### Flatpak ###

You can also install using flatpak, which should work for every Linux distribution
```sh
flatpak install org.gnome.Sdk//3.30 org.gnome.Platform//3.30
flatpak-builder --install --user --force-clean _flatbuild ch.gnugen.Moody.json
```
For some reason, you may need to install elfutils `sudo apt install elfutils`  
Flatpak will build libhandy and myhtml from their repositry, and use libsoup and libsecret
from the Gnome runtime.

You can also install it system-wide by removing the `--user` flags.

you may need to [https://flatpak.org/setup/](install flatpak) for it to work

## Build it Yourself ##

### Gnome Builder ###

If you are fond of graphical interfaces, get Gnome Builder (`flatpak install org.gnome.Builder`)
and ask it to clone the repositry. Have a look at the code while it gets the dependencies!

### Meson ###

Alternatively, you can install it system-wide outside of the flatpak sandbox;

You first need to install [https://github.com/lexborisov/myhtml](myhtml)
or the modest rendering engine; libhandy, libsecret and libsoup.
You may find these in your repos.

```sh
git clone https://gitlab.gnugen.ch/afontain/moodle.git
cd moodle
meson build-dir
ninja -C build-dir
ninja -C build-dir install
```

## Features ##

### Cache ###

There is a cache system, but it currently uses the build dir
and must be activated either always or never at compile time
(see `CACHING` in config.h.in). For now, this is a feature used
(and usable) for development purpose only; and it doesn't work
with files, yet.

## Future Work ##

There is a lot to do: making use of GLib's GTask, loading courses
from cache intelligently, adding the ability to read files inside folders,
read files from cache…
